/*-
 * ~~~~~~licensing~~~~~~
 * profile-runtime
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.profiles.runtime.impl;

import ru.entaxy.platform.profiles.runtime.Connector;

public abstract class AbstractConnector implements Connector {

	public static final String PROP_ID = "id";
	public static final String PROP_TYPE = "type";
	public static final String PROP_PROTOCOL = "protocol";
	public static final String PROP_CLASSIFIER = "classifier";
	
	public static final String CONNECTOR_PREFIX = "connector.";
	
	protected String id;
	protected String type;
	protected String protocol;
	protected String classifier;
	
	
	@Override
	public String getId() {
		return this.id;
	}

	@Override
	public String getType() {
		return this.type;
	}

	@Override
	public String getProtocol() {
		return this.protocol;
	}

	@Override
	public String getClassifier() {
		return this.classifier;
	}

	@Override
	public String getProperty(String propertyName) {
		String name = propertyName;
		if (name.startsWith(CONNECTOR_PREFIX))
			name = name.substring(CONNECTOR_PREFIX.length());
		if (PROP_ID.equals(name))
			return getId();
		if (PROP_TYPE.equals(name))
			return getType();
		if (PROP_PROTOCOL.equals(name))
			return getProtocol();
		if (PROP_CLASSIFIER.equals(name))
			return getClassifier();
		return null;
	}

	public void setId(String id) {
		this.id = id;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}

	public void setClassifier(String classifier) {
		this.classifier = classifier;
	}

	
	
}
